package model;

import java.util.ArrayList;

public class Knight extends Piece {


    public Knight(Position p, int color) {
        super(p, color);
    }


    public ArrayList<Position> getAvailableMoves(Board b) {

        // creates a dynamic list of available moves
        ArrayList<Position> moves = new ArrayList<>();
        Position arrival;

        // list of the 8 knight specific movements
        int[] all_x = {1, 2, 2, 1, -1, -2, -2, -1};
        int[] all_y = {2, 1, -1, -2, -2, -1, 1, 2};

        for(int n = 0 ; n < all_x.length ; n++) { // for each direction
            int x = all_x[n];
            int y = all_y[n];
            arrival = new Position(p.getX() + x, p.getY() + y);
            if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
                moves.add(arrival);
            }
        }

        // Full wrote version : --------------------------
        /*
        arrival = new Position(p.getX() - 1, p.getY() + 2);
        if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        // up right
        arrival = new Position(p.getX() + 1, p.getY() + 2);
        if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        // down left
        arrival = new Position(p.getX() - 1, p.getY() - 2);
        if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        //down right
        arrival = new Position(p.getX() + 1, p.getY() - 2);
        if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        arrival = new Position(p.getX() - 2, p.getY() + 1);
        if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        // up right
        arrival = new Position(p.getX() + 2, p.getY() + 1);
        if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }
        // down left
        arrival = new Position(p.getX() - 2, p.getY() - 1);
        if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        //down right
        arrival = new Position(p.getX() + 2, p.getY() - 1);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }*/
        // -----------------------------------------------

        return moves;
    }

    public Piece newInstanceCopy() {
        return new Knight(p, color);
    }
}
