package view;

import javafx.scene.image.Image;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;

public class CustomMaterial {

	private static PhongMaterial[] material;
	public static final int
			BLACK = 0, WHITE = 1, SELECTED_TILE = 2, MOVABLE_TILE = 3,
			ATTACK_TILE = 4, SPECIAL_TILE = 5, BLACK_TILE = 6, WHITE_TILE = 7, WOOD = 8, EXPLOSION_TILE = 9, CARPET = 10, STUDIO_WALL = 11;
	private static final int MATERIAL_LENGTH = 12;

	public CustomMaterial() {
		material = new PhongMaterial[MATERIAL_LENGTH];
		material[BLACK] = new PhongMaterial();
		material[BLACK].setDiffuseColor(Color.rgb(20,20,20));
		material[WHITE] = new PhongMaterial();
		material[WHITE].setDiffuseColor(Color.rgb(240,240,240));
		material[SELECTED_TILE] = new PhongMaterial();
		material[SELECTED_TILE].setDiffuseColor(Color.rgb(40,150,60));
		material[MOVABLE_TILE] = new PhongMaterial();
		material[MOVABLE_TILE].setDiffuseColor(Color.rgb(50,200,80));
		material[ATTACK_TILE] = new PhongMaterial();
		material[ATTACK_TILE].setDiffuseColor(Color.rgb(200,50,50));
		material[SPECIAL_TILE] = new PhongMaterial();
		material[SPECIAL_TILE].setDiffuseColor(Color.rgb(120,20,255));
		material[BLACK_TILE] = new PhongMaterial();
		material[BLACK_TILE].setDiffuseColor(Color.grayRgb(64));
		material[WHITE_TILE] = new PhongMaterial();
		material[WHITE_TILE].setDiffuseColor(Color.grayRgb(200));
		material[WOOD] = new PhongMaterial();
		material[WOOD].setDiffuseMap(new Image("/wood.jpg"));
		material[EXPLOSION_TILE] = new PhongMaterial();
		material[EXPLOSION_TILE].setDiffuseColor(Color.rgb(200, 80, 50));
		material[CARPET] = new PhongMaterial();
		material[CARPET].setDiffuseMap(new Image("/carpet.jpg"));
		material[STUDIO_WALL] = new PhongMaterial();
		material[STUDIO_WALL].setDiffuseMap(new Image("/studio_wall.jpg"));

		for(int i = 0 ; i < MATERIAL_LENGTH ; i++) {
			material[i].setSpecularColor(Color.rgb(100, 100, 100));
		}
		material[BLACK].setSpecularColor(Color.WHITE); // more intense reflection for black
		material[CARPET].setSpecularColor(Color.BLACK);
		material[STUDIO_WALL].setSpecularColor(Color.BLACK);
	}

	public PhongMaterial get(int type) {
		return material[type];
	}
}
