package view;

import javafx.scene.Group;
import javafx.scene.shape.Box;

public class Desk {
	private final Box desk;
	private final Box[] desk_leg;
	public Desk(CustomMaterial material) {
		// desk board
		int table_size = BoardView.BOARD_SIZE*12;
		int leg_size = BoardView.BOARD_SIZE*8;
		desk = new Box(table_size*2, BoardView.BOARD_SIZE, table_size);
		desk.translateYProperty().set((double) BoardView.BOARD_SIZE /2);
		desk.setMaterial(material.get(CustomMaterial.WOOD));
		// desk legs
		desk_leg = new Box[4];
		for(int j = -1, n = 0; j <= 1 ; j+=2) {
			for(int i = -1 ; i <= 1 ; i+=2 , n++) {
				desk_leg[n] = new Box(BoardView.BOARD_SIZE, leg_size, BoardView.BOARD_SIZE);
				desk_leg[n].setMaterial(material.get(CustomMaterial.WOOD));
				desk_leg[n].translateYProperty().set((double) BoardView.BOARD_SIZE/2 + leg_size/2 + BoardView.BOARD_SIZE/2);
				desk_leg[n].translateXProperty().set((double) i * (table_size - BoardView.BOARD_SIZE/2));
				desk_leg[n].translateZProperty().set((double) j * (table_size/2 - BoardView.BOARD_SIZE/2));
			}
		}


	}

	public void addAllToScene(Group group) {
		group.getChildren().add(desk);
		for(int n = 0 ; n < 4 ; n++) {
			group.getChildren().add(desk_leg[n]);
		}
	}
}
